import { RRule, RRuleSet, rrulestr } from "rrule";
import { getHomeUserSchedule1 } from "../../api/request";
import {
  getFormatDate,
  getCurrentMonthFirst,
  getCurrentMonthLast
} from "../../utils/utils";
Component({
  mixins: [],
  data: {
    isShowSidebar: "",
    response: [],
    scheduleList: [],
    startPageOnShow: false,
    pageStartTime: "",
    pageEndTime: "",
    isFirstLoad: true,
    show: false,
    scrollHeight: "",
    timeStamp: ""
  },
  props: {},
  didMount() {
    console.log(this);
    let that = this;
    // TODO 时间处理，前后三个月的时间
    let now = new Date();
    let year = now.getFullYear();
    let month = now.getMonth() + 1;
    let day = now.getDate();
    let parmsStartDate = this.returnMonthActionAndEndDate(year, month - 2, day)
      .startDay;
    let parmsEndDate = this.returnMonthActionAndEndDate(year, month + 2, day)
      .endDay;

    let startTime = getFormatDate(
      new Date(year, month - 2, parmsStartDate),
      "yyyyMMdd",
      "-"
    );
    let endTime = getFormatDate(
      new Date(year, month + 2, parmsEndDate),
      "yyyyMMdd",
      "-"
    );
    let data = {
      startTime: `${startTime} 00:00:00`,
      endTime: `${endTime} 23:59:59`
    };
    getHomeUserSchedule1(data).then(res => {
      this.setData(
        {
          response: res.data.data
        },
        () => {
          let scheduleList = [];
          for (let i = -2; i <= 2; i++) {
            let forDate = new Date(year, month + i, 1);
            scheduleList.push(
              that.returnScheduleList(forDate.toLocaleDateString())
            );
          }
          console.log(scheduleList);
          this.setData({
            scheduleList: scheduleList,
            pageStartTime: new Date(year, month - 3, 1).toLocaleDateString(),
            pageEndTime: new Date(year, month + 2, 1).toLocaleDateString()
          });
        }
      );
    });
  },
  didUpdate() {},
  didUnmount() {},
  methods: {
    closePop() {
      this.setData({
        show: false
      });
    },
    changesidebar() {
      this.setData({
        show: true
      });
    },
    preventSort() {
      return false;
    },
    // 返回删除的日期
    returnExcludeDate(data) {
      let returnData = {
        scheduleList: [],
        templateList: []
      };
      data.map(item => {
        if (item.length > 10) {
          returnData.templateList.push(
            new Date(item.slice(6, 16).replace(/-/g, "/")).getTime()
          );
        } else {
          returnData.scheduleList.push(item);
        }
      });
      return {
        scheduleList: returnData.scheduleList,
        templateList: Math.min(...returnData.templateList)
      };
    },
    // 生成用户时间段内的会议日程并返回会议日程List
    getCalendarList() {
      let that = this;
      // 定义map数据结构
      let scheduleMap = new Map();
      // 对规则内的
      if (this.data.response) {
        this.data.response.templateList.map(item => {
          // TO DO 判断所获取的时间区间
          // 将会议的年，月，日拆分，时分拆分，生成rrules规则
          let terminateTimeList = item.initialTime.split("-"); //
          let startTimeList = item.startTime.split(":");
          let DTSTART = `${terminateTimeList[0]}${terminateTimeList[1]}${terminateTimeList[2]}T${startTimeList[0]}${startTimeList[1]}00Z`;
          let rule = RRule.fromString(
            `${item.recurrenceModel.recurrenceRule};DTSTART=${DTSTART}`
          );
          // 改变时区
          rule.options.tzid = "Asia/Hong_Kong";
          // 判断是否需要剔除某一天
          if (item.excludePlanDates) {
            // 拿到剔除日期的list
            let excludeDateList = that.returnExcludeDate(
              item.excludePlanDates.split(",")
            );
            rule.all().map(item2 => {
              let excludeDate = getFormatDate(item2, "yyyyMMdd");
              let hasExclude =
                excludeDateList.scheduleList.indexOf(excludeDate) === -1;
              if (
                new Date(item2).getTime() < excludeDateList.templateList &&
                hasExclude
              ) {
                let startTime =
                  getFormatDate(item2, "yyyyMMdd") +
                  " " +
                  item.recurrenceModel.startTime;
                let endTime = new Date(startTime);
                endTime.setMinutes(
                  endTime.getMinutes() + item.recurrenceModel.duration
                );
                scheduleMap.set(
                  `${new Date(item2).toLocaleDateString()}/${item.id}`,
                  {
                    confirmAttendance: item.confirmAttendance,
                    endTime: getFormatDate(endTime, "yyyyMMdd HH:mm:ss"),
                    id: item.id,
                    startTime: startTime,
                    title: item.title,
                    planDate: getFormatDate(item2, "yyyyMMdd")
                  }
                );
              }
            });
          } else {
            rule.all().map(item2 => {
              let startTime =
                getFormatDate(item2, "yyyyMMdd") +
                " " +
                item.recurrenceModel.startTime;
              let endTime = new Date(
                getFormatDate(item2, "yyyyMMdd") +
                  " " +
                  item.recurrenceModel.startTime
              );
              endTime.setMinutes(
                endTime.getMinutes() + item.recurrenceModel.duration
              );
              scheduleMap.set(
                `${new Date(item2).toLocaleDateString()}/${item.id}`,
                {
                  confirmAttendance: item.confirmAttendance,
                  endTime: getFormatDate(endTime, "yyyyMMdd HH:mm:ss"),
                  id: item.id,
                  startTime: startTime,
                  title: item.title,
                  planDate: getFormatDate(item2, "yyyyMMdd")
                }
              );
            });
          }
        });
        let scheduleList = [];
        this.data.response.scheduleList.map(item => {
          if (!item.scheduleTemplateId) {
            scheduleList.push(item);
          } else if (
            item.scheduleTemplateId &&
            scheduleMap.get(
              `${item.planDate.replace(/-/g, "/")}/${item.scheduleTemplateId}`
            )
          ) {
            scheduleMap.set(
              `${item.planDate.replace(/-/g, "/")}/${item.scheduleTemplateId}`,
              item
            );
          }
        });
        scheduleMap.forEach(function(value, key, map) {
          scheduleList.push(value);
        });
        return scheduleList;
      } else {
        return [];
      }
    },
    returnMonthActionAndEndDate(year, month, date) {
      let days = this.returnDayMany(year, month, date);
      let startDay =
        new Date(year, month, 1).getDay() === 0
          ? 1
          : 7 - new Date(year, month, 1).getDay() + 1;
      let endDay = days + 7 - new Date(year, month, days).getDay();
      return {
        startDay: startDay,
        endDay: endDay
      };
    },
    // 生成一年内的渲染数据
    returnMonthMap(year, month, date) {
      let monthDay = this.returnMonthActionAndEndDate(year, month, date);
      let monthMap = new Map();
      for (let i = monthDay.startDay; i < monthDay.endDay; i++) {
        monthMap.set(`${new Date(year, month, i).toLocaleDateString()}`, {
          scheduleList: []
        });
      }
      return monthMap;
    },
    returnScheduleList(date) {
      let that = this;
      let argumentsDate = new Date(date);
      let year = argumentsDate.getFullYear();
      let month = argumentsDate.getMonth();
      let day = argumentsDate.getDate();
      let calendarList = this.getCalendarList();
      let monthMap = this.returnMonthMap(year, month, day);
      let weekList = ["周日", "周一", "周二", "周三", "周四", "周五", "周六"];
      // 遍历所有日程
      for (let y = 0; y < calendarList.length; y++) {
        let date1 = calendarList[y].startTime.slice(0, 10).replace(/-/g, "/");
        let date2 = calendarList[y].endTime.slice(0, 10).replace(/-/g, "/");
        let count = this.count(date1, date2);
        // 不跨天
        if (count == 0) {
          // 每年的第一周和跨天的那几天有日程就push进去
          if (
            monthMap.get(
              `${new Date(
                calendarList[y].startTime.replace(/-/g, "/")
              ).toLocaleDateString()}`
            )
          ) {
            monthMap
              .get(
                `${new Date(
                  calendarList[y].startTime.replace(/-/g, "/")
                ).toLocaleDateString()}`
              )
              .scheduleList.push({
                ...calendarList[y],
                thisDayStartTime: calendarList[y].startTime.slice(11, 16),
                thisDayEndTime: calendarList[y].endTime.slice(11, 16),
                isBeOverdue:
                  new Date().getTime() >
                  new Date(calendarList[y].endTime.replace(/-/g, "/")).getTime()
                    ? true
                    : false
              });
          }
        }
        // 跨天
        else {
          for (let j = 0; j <= count; j++) {
            let time = new Date(date1);
            time.setDate(time.getDate() + j);
            if (
              monthMap.get(
                new Date(
                  time.getFullYear(),
                  time.getMonth(),
                  time.getDate()
                ).toLocaleDateString()
              )
            ) {
              monthMap
                .get(
                  new Date(
                    time.getFullYear(),
                    time.getMonth(),
                    time.getDate()
                  ).toLocaleDateString()
                )
                .scheduleList.push({
                  ...calendarList[y],
                  isfirstDayOrEndDay: j === 0 ? "0" : j === count ? "2" : "1", // 0 第一天，1中间的天，2结束的天
                  thisDayStartTime: calendarList[y].startTime.slice(11, 16),
                  thisDayEndTime: calendarList[y].endTime.slice(11, 16),
                  isFewDays: j + 1,
                  duration: count + 1,
                  isBeOverdue:
                    new Date().getTime() >
                    new Date(
                      calendarList[y].endTime.replace(/-/g, "/")
                    ).getTime()
                      ? true
                      : false
                });
            }
          }
        }
      }
      let DateList = [];
      // 第一个月的第一天
      let thisDay = new Date().toLocaleDateString();
      monthMap.forEach(function(value, key, map) {
        if (new Date(key).getDay() === 0) {
          let rangeYear1 = new Date(key).getFullYear();
          let rangeMonth1 = new Date(key).getMonth();
          let rangeDay1 = new Date(key).getDate();
          let rangeDate = new Date(rangeYear1, rangeMonth1, rangeDay1 + 6);
          let rangeMonth2 = new Date(rangeDate).getMonth();
          let rangeDay2 = new Date(rangeDate).getDate();
          DateList.push({
            type: "week",
            value: `第${that.getYearWeek(key)}周，${rangeMonth1 +
              1}月${rangeDay1}日 - ${
              rangeMonth2 == rangeMonth1 ? "" : rangeMonth2 + 1 + "月"
            }${rangeDay2}日`,
            dayStr: key
          });
        }
        // 有日程长度 并且不是今天
        if (value.scheduleList.length !== 0 && key !== thisDay) {
          DateList.push({
            type: "day",
            isThisDay: true,
            value: {
              value: value.scheduleList,
              day:
                new Date(key).getDate() < 10
                  ? "0" + new Date(key).getDate()
                  : new Date(key).getDate(),
              week: weekList[new Date(key).getDay()]
            }
          });
        }
        // 有日程长度，并且是今天
        else if (value.scheduleList.length !== 0 && key === thisDay) {
          DateList.push({
            type: "today",
            value: {
              value: value.scheduleList,
              day:
                new Date(key).getDate() < 10
                  ? "0" + new Date(key).getDate()
                  : new Date(key).getDate(),
              week: weekList[new Date(key).getDay()],
              dateStr: key
            }
          });
        }
        if (value.scheduleList.length === 0 && key === thisDay) {
          DateList.push({
            type: "thisDay",
            value: {
              value: value.scheduleList,
              day:
                new Date(key).getDate() < 10
                  ? "0" + new Date(key).getDate()
                  : new Date(key).getDate(),
              week: weekList[new Date(key).getDay()],
              dateStr: key
            }
          });
        }
      });
      DateList.unshift({
        type: "month",
        value: month + 1
      });
      if (month === 0) {
        DateList.unshift({
          type: "year",
          value: year
        });
      }
      return DateList;
    },
    // 获取今天是每个月的第几周
    getYearWeek(date) {
      /*  
          date1是当前日期
          date2是当年第一天
          d是当前日期是今年第多少天
          用d + 当前年的第一天的周差距的和在除以7就是本年第几周
      */
      var date1 = new Date(date);
      var date2 = new Date(date1.getFullYear(), 0, 1);
      var d = Math.round((date1.valueOf() - date2.valueOf()) / 86400000);
      return Math.ceil((d + (date2.getDay() + 1 - 1)) / 7);
    },
    // 是否跨天 返回跨天数
    count(date1, date2) {
      var date1 = new Date(date1);
      var date2 = new Date(date2);
      var date =
        (date2.getTime() - date1.getTime()) /
        (1000 * 60 * 60 * 24); /*不用考虑闰年否*/
      return date;
    },
    // 返回指定月份天数
    returnDayMany(year, month, date) {
      var selectedDate = new Date(year, month, date);
      var selectedMonth = selectedDate.getMonth() + 1;
      selectedDate.setMonth(selectedMonth);
      selectedDate.setDate(0);
      return selectedDate.getDate();
    },
    onScroll(e) {
      // console.log(e);
      // if (!this.data.scrollHeight || !this.data.timeStamp) {
      //   this.setData({
      //     scrollHeight: e.detail.scrollTop,
      //     timeStamp: e.timeStamp
      //   });
      // } else {
      //   let height = e.detail.scrollTop - this.data.scrollHeight;
      //   let time = e.timeStamp - this.data.timeStamp;
      //   let v = height / time;
      //   console.log(v);
      //   this.setData({
      //     scrollHeight: e.detail.scrollTop,
      //     timeStamp: e.timeStamp
      //   });
      // }
    },
    onScrollToUpper() {
      let that = this;
      let now = new Date(this.data.pageStartTime);
      let year = now.getFullYear();
      let month = now.getMonth() + 1;
      let day = now.getDate();
      let parmsDate = this.returnMonthActionAndEndDate(year, month - 1, day);
      let startTime = getFormatDate(
        new Date(year, month - 1, parmsDate.startDay),
        "yyyyMMdd",
        "-"
      );
      let endTime = getFormatDate(
        new Date(year, month - 1, parmsDate.endDay),
        "yyyyMMdd",
        "-"
      );
      let data = {
        startTime: `${startTime} 00:00:00`,
        endTime: `${endTime} 23:59:59`
      };
      getHomeUserSchedule1(data).then(res => {
        this.setData(
          {
            response: res.data.data
          },
          () => {
            let scheduleList = [...this.data.scheduleList];
            let forDate = new Date(year, month, 1);
            scheduleList.unshift.apply(
              scheduleList,
              that.returnScheduleList(forDate.toLocaleDateString())
            );
            this.setData({
              scheduleList: scheduleList,
              pageStartTime: new Date(year, month - 2, 1).toLocaleDateString()
            });
          }
        );
      });
    },
    loadMoreDate() {
      let that = this;
      let now = new Date(this.data.pageEndTime);
      let year = now.getFullYear();
      let month = now.getMonth() + 1;
      let day = now.getDate();
      let parmsDate = this.returnMonthActionAndEndDate(year, month + 1, day);
      let startTime = getFormatDate(
        new Date(year, month + 1, parmsDate.startDay),
        "yyyyMMdd",
        "-"
      );
      let endTime = getFormatDate(
        new Date(year, month + 1, parmsDate.endDay),
        "yyyyMMdd",
        "-"
      );
      let data = {
        startTime: `${startTime} 00:00:00`,
        endTime: `${endTime} 23:59:59`
      };
      getHomeUserSchedule1(data).then(res => {
        that.setData(
          {
            response: res.data.data
          },
          () => {
            let forDate = new Date(year, month, 1);
            let scheduleList = that.returnScheduleList(
              forDate.toLocaleDateString()
            );
            console.log([scheduleList]);
            that.setData({
              ["scheduleList[" +
              that.data.scheduleList.length +
              "]"]: scheduleList,
              pageEndTime: new Date(year, month, 1).toLocaleDateString()
            });
            console.log(that.data.scheduleList);
          }
        );
      });
    }
  }
});
